=== debian/changelog ===
bmagic (5.0.0-1) unstable; urgency=medium

  * New upstream release (Closes: #872584)
  * Remove Wes Chow as uploader
  * Update to dh compat level 10
  * Drop obsolete patches
  * Update to Standards-Version 4.4.0 (no changes)
  * Mark bmagic binary package as 'Multi-Arch: foreign'
  * Switch build to use CMake
  * Update package copyright information (including upstream change to Apache
    license version 2.0)

 -- Roberto C. Sanchez <roberto@connexer.com>  Tue, 13 Aug 2019 23:51:26 -0400
